'------------------------------------------------------------------------
'
'          DCF77 Uhr fr das Pollin Spiel nach DH2FAA
'          von DG0OM modifiziert mit UTC-Anzeige
'
'            Pollin DCF77-8100054
'           |----------|
'           | Ant    O | +3,3V  ----------*---*--R---- +5V (Vcc)
'           |        O | GND              |   |
'           | Qu     O | Data     PB7     C   Z        R=680Ohm
'           |        O | PON-GND  PB6     |   |        C=100nf
'           | Elko     |                  -   -        Z=3,3V/500mA
'           |----------|                     GND
'
'
$regfile = "attiny2313.dat"

Lcd_db4 Alias Portb.0
Lcd_db5 Alias Portb.1
Lcd_db6 Alias Portb.2
Lcd_db7 Alias Portb.3
Lcd_e Alias Porta.0
Lcd_rs Alias Porta.1

Lcd_ein Alias Portd.6
Config Lcd_ein = Output

Lcd_kontrast Alias Portb.4
Config Lcd_kontrast = Output


$framesize = 40
$swstack = 10
$hwstack = 32

$crystal = 8000000                                          'divisor 8 ist disabled


Config Lcdmode = Port
Config Lcd = 16 * 2 , Chipset = Ks077

Config Lcdbus = 4
Config Lcdpin = Pin , Db4 = Lcd_db4 , Db5 = Lcd_db5 , Db6 = Lcd_db6 , Db7 = Lcd_db7 , E = Lcd_e , Rs = Lcd_rs

Config Dcf77 = Pinb.7 , Inverted = 0 , Timer = 1 , Debug = 0 , Check = 1 , Gosub = Sectic



Idcf Alias Pinb.7
Reset Portb.7                                               ' pull-up- off; wichtig !!!

Oled Alias Portd.4
Config Oled = Output

Dcfpon Alias Portb.6
Config Dcfpon = Output

Set Dcfpon

Declare Sub Showtime_lcd()
Declare Sub Init

Dim Tz As Byte
Dim Minute As Byte
Dim Stunde As Byte
Dim Idcf As Bit

Reset Oled
Set Dcfpon
Set Oled
Call Init
Reset Oled
Reset Dcfpon

Initlcd
 Cls
 Cursor Off

Enable Interrupts



'
Do
  If Idcf = 1 Then
  Set Oled
  Else
  Reset Oled
  End If
Loop
End

'optional, is called every second by the library
Sectic:
If Dcf_status.7 = 1 Then

  Tz = Dcf77timezone()

    Locate 2 , 1
         If Stunde < 10 Then
         Lcd "0" ; Stunde ; ":"
    Else
         Lcd Stunde ; ":"
    End If

    Locate 2 , 4
         If Minute < 10 Then
         Lcd "0" ; Minute
    Else
         Lcd Minute
    End If
        Locate 2 , 6
        Lcd "UTC  "

        Locate 1 , 1
    Lcd Time$

'mit neuer Var UTC rechnen
Minute = _min
Stunde = _hour

'umrechnen auf UTC
If Tz = 1 Or Tz = 2 Then Stunde = _hour - Tz
If _hour = 0 Then Stunde = 24 - Tz
If _hour = 1 And Tz = 2 Then Stunde = 25 - Tz
If _hour = 1 And Tz = 1 Then Stunde = 1 - Tz
Else
    Locate 1 , 1
    Lcd "warten"
    Locate 2 , 1
    Lcd Time$

End If

Return

 Sub Init

   Set Lcd_ein
   Set Lcd_kontrast

   Initlcd
   Cursor Off
   Cls
   Locate 1 , 2
    Lcd "DCF77"
   Locate 2 , 2
    Lcd "UTC"
   Wait 5
   Cls
   Cursor Off

End Sub

End